LPARAMETERS pcPar01, pcPar02, pcPar03, pcPar04, pcPar05, pcPar06, pcPar07, pcPar08, pcPar09


#INCLUDE "Foxpro.H"
#INCLUDE "myCPzero.h"



*	Pro VFP jsou vyhrazeny tyto commandline params:
*	-A	-Bfile	-Cfile	-Dfile	-Lfile	-R	-T	/nologo

*       myCPzero
*
cRelease=chr(255)
IF .not.empty(AGETFILEVERSION(aVerInfo, sys(16, 0)))
	cRelease="rel.: "+Alltrim(Transform(aVerInfo[4]))
	release aVerInfo
ENDIF
cProgram="myCPzero"

IF .not.FirstInstance(cProgram)
   MessageBox(mcERR01, 0+16, cProgram)
   QUIT
ENDIF

DO FORM myInfoWindow NAME frmWait WITH cProgram, "", mcMSG01
frmWait.Akce("Nastaven prosted aplikace")
frmWait.Logging("Definice pamovch promnnch")

store [] to cCfgFile, cIniFile, cLogFile, cHelpFile, cDataDir, cDSN, cPassword, cLogin
store 60 to nLogFileExpireDays

SetEnvironment(cProgram)		&& std files, SETtings
SET MULTILOCKS ON

*****	 errhandler pro vybrane chyby (1707:	CDX not found je std. osetren pomoci RETRY)
store .F. to lErr1733, lErr1429, lErr1426, lErr1943, lErr1440, lErr1923, lErr3, lErr41
* aAddRow(@aErrTrap, 1733, [store .T. to lErr1733])	&& 1733 Class definition ... is not found.
* aAddRow(@aErrTrap, 1426, [store .T. to lErr1426])	&& OLE error code 0x80020006
* aAddRow(@aErrTrap, 1429, [store .T. to lErr1429])	&& OLE IDispatch exception code 4096
* aAddRow(@aErrTrap, 1440, [store .T. to lErr1440])	&& OLE exception error: Exception code c0000005. OLE object may be corrupt
* aAddRow(@aErrTrap, 1943, [store .T. to lErr1943])	&& Member ... does not evaluate
* aAddRow(@aErrTrap, 1923, [store .T. to lErr1923])	&& Object not found
aAddRow(@aErrTrap, 3, [store .T. to lErr3])	&& File is in use
aAddRow(@aErrTrap, 41, [store .T. to lErr41])	&& Memo file XXX is missing or is invalid.

ON SHUTDOWN do ProgramShutdown

* ON ERROR
* _SCREEN.Visible=.T.

cINIfile=iif( file(cINIfile), FullPath(cINIfile), ForcePath(cINIfile, JustPath(sys(16, 0))) )
frmWait.Logging("ten INI souboru ", cINIfile)

Logging(mcMSG09)
Logging(mcMSG10+"Common/INIFILE: "+FullPath(cINIfile)+iif(file(cINIfile), " ", " not ")+"present")
Logging(mcMSG10+"Common/CFGFILE: "+FullPath(cCfgfile)+iif(file(cCFGfile), " ", " not ")+"present")
Logging(mcMSG10+"Common/HELPFILE: "+FullPath(cHelpfile)+iif(file(cHELPfile), " ", " not ")+"present")
Logging(mcMSG10+"Common/LogFileExpireDays: "+Transform(nLogFileExpireDays))

cDDStable=GetIniPar(cIniFile, "DDStable", cProgram, [myCPzero.DDS])
Logging(mcMSG10, cProgram, "/DDStable: "+cDDStable)

lMinimizeToSysTray=InList( Upper(GetIniPar(cIniFile, "MinimizeToSysTray", cProgram, [YES])),						;
					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
Logging(mcMSG10, cProgram, "/MinimizeToSysTray: "+iif(lMinimizeToSysTray, "YES", "NO"))

lDebugMode=InList( Upper(GetIniPar(cIniFile, "DebugMode", cProgram, [NO])),						;
					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
Logging(mcMSG10, cProgram, "/DebugMode: "+iif(lDebugMode, "YES", "NO"))

lCheckClasses=InList( Upper(GetIniPar(cIniFile, "CheckClasses", cProgram, [NO])),						;
					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& kontrola dostupnosti OLE server a CLASS
Logging(mcMSG10, cProgram, "/CheckClasses: ", iif(lCheckClasses, "YES", "NO"))

cKeyboardLayout=GetIniPar(cIniFile, "KeyboardLayout", cProgram, [09])			&& default EN
Logging(mcMSG10, cProgram, "/KeyboardLayout: "+cKeyboardLayout)

*nFlushInterval=val(GetIniPar(cIniFile, "FlushInterval", cProgram, [5]))			&& interval zpisu bufferu na disk
*Logging(mcMSG10, cProgram, "/FlushInterval: "+Transform(nFlushInterval))

*cUSERS=GetIniPar(cIniFile, "USERS", cProgram, [USERS])			&& spolen sov tabulka
*Logging(mcMSG10, cProgram, "/USERS: "+cUSERS)

*cParam01=GetIniPar(cIniFile, "param01", "Common")
*Logging(mcMSG10+"Common/param01: "+cParam01)

*cParam02=GetIniPar(cIniFile, "param02", cProgram, [Param02])			&& char param
*Logging(mcMSG10, cProgram, "/param02: "+cParam02)

*lParam03=InList( Upper(GetIniPar(cIniFile, "param03", cProgram, [NO])),						;
*					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
*Logging(mcMSG10, cProgram, "/param03: "+iif(lParam03, "YES", "NO"))

*nParam04=val(GetIniPar(cIniFile, "param04", cProgram, [0]))			&& num param
*Logging(mcMSG10, cProgram, "/param04: "+Transform(nParam04))


***** definice nepevdnch pol pro rzn typy tabulek
cSCXnoCPtrans=GetIniPar(cIniFile, "SCXnoCPtrans", cProgram, [OBJCODE, OLE])			&& char param
Logging(mcMSG10,  cProgram, "/SCXnoCPtrans: "+cSCXnoCPtrans)
cMNXnoCPtrans=GetIniPar(cIniFile, "MNXnoCPtrans", cProgram, [])			&& char param
Logging(mcMSG10,  cProgram, "/MNXnoCPtrans: "+cMNXnoCPtrans)
cVCXnoCPtrans=GetIniPar(cIniFile, "VCXnoCPtrans", cProgram, [OBJCODE, OLE])			&& char param
Logging(mcMSG10,  cProgram, "/VCXnoCPtrans: "+cVCXnoCPtrans)
cFRXnoCPtrans=GetIniPar(cIniFile, "FRXnoCPtrans", cProgram, [])			&& char param
Logging(mcMSG10,  cProgram, "/FRXnoCPtrans: "+cFRXnoCPtrans)
cLBXnoCPtrans=GetIniPar(cIniFile, "LBXnoCPtrans", cProgram, [])			&& char param
Logging(mcMSG10,  cProgram, "/LBXnoCPtrans: "+cLBXnoCPtrans)
cPJXnoCPtrans=GetIniPar(cIniFile, "PJXnoCPtrans", cProgram, [])			&& char param
Logging(mcMSG10,  cProgram, "/PJXnoCPtrans: "+cPJXnoCPtrans)
cDBFnoCPtrans=GetIniPar(cIniFile, "DBFnoCPtrans", cProgram, [])			&& char param
Logging(mcMSG10,  cProgram, "/DBFnoCPtrans: "+cDBFnoCPtrans)


dimension aAllowedExt(1)
aFillRow(@aAllowedExt,  1, "*.dbf")
aFillRow(@aAllowedExt, 99, "*.scx")
aFillRow(@aAllowedExt, 99, "*.mnx")
aFillRow(@aAllowedExt, 99, "*.vcx")
aFillRow(@aAllowedExt, 99, "*.frx")
aFillRow(@aAllowedExt, 99, "*.lbx")
aFillRow(@aAllowedExt, 99, "*.pjx")


IF lCheckClasses
***** Kontrola pouzitych OCX a DLL
frmWait.Logging("Kontrola pouitch td a COM server")
local array xaClasses(1)
local xcMsg
aFillRow(@xaClasses, 1, [])
aAddRow(@xaClasses, [MSMAPI.MAPISession.1])
aAddRow(@xaClasses, [TRAYICO.TrayIcoCtrl.1])
aAddRow(@xaClasses, [SAWZip.Archive.1])
aAddRow(@xaClasses, [])
xcMsg=CheckClassesRegistration(@xaClasses)
xcMsg=xcMsg+iif(file([zlib.dll]), [], chr(10)+[zlib.dll not found])
IF .not.empty(xcMsg)
	MessageBox(mcERR02+xcMsg, 16, cProgram)
	Logging(mcERR02+xcMsg)
ENDIF
release xcMsg, xaClasses
ENDIF


*	pozice obrazovky
store -1 to gnLeft, gnTop, gnHeight, gnWidth
*	vstupni soubor a adresar, vystupni soubor
store [] to gcInputFile, gcInputDir, gcOutputFile, gcProgramVersion

***************** globln promnn

store "" to gcDIRNAME
store "*.dbf" to gcMASKA
store CPcurrent() to gnNewCP
store .T. to glREINDEX
store .F. to glTEXTY


If file(cCfgFile)                       && config file (all g* variables saved)
  restore from (cCfgFile) additive
endif
save all like g* to (cCfgFile)

CreateCursorSEZNAM()		&& pokud jet neexistuje, zalo ho, jinak ho ZAPuje

gnHelpContextId=41
lMainCyklus=.T.
store .F. to lErrors, lModified

*****	prepnuti na pozadovanou klavesnici
frmWait.Logging("Pepnut klvesnice")
IF .not.ActivateKeyboard(cKeyboardLayout)
	Logging([Nepodailo se pepnut na poadovan rozloen klves: ], cKeyboardLayout)
ENDIF

***	je nov verze programu - kontrola datovch struktur?
frmWait.Logging("Kontrola verze programu")
lNewProgramVersion=.F.
IF .not.(cRelease==gcProgramVersion)
	Logging("Zmna verze programu: ", gcProgramVersion, " -> ", cRelease)
	lNewProgramVersion=.T.
	gcProgramVersion=cRelease
ENDIF

frmWait.Release()
IIF(lDebugMode, MessageBox(mcMSG02, 0, cProgram), .T.)

DO WHILE lMainCyklus
	lMainCyklus=.F.

	DO FORM myCPzero NAME frmmyCPzero
	READ EVENTS

ENDDO
Logging(mcMSG04)

QUIT

*****

FUNCTION ProgramShutdown()

DO FORM myInfoWindow NAME frmWait WITH cProgram, "", ""
frmWait.Akce("")
frmWait.ProgressBar(1/5*100)
clear events
ON SHUTDOWN
close databases
Logging(mcMSG08)

close all
GetNewTmp([Delete])
save all like g* to (cCfgFile)
frmWait.Release()

QUIT


*****

FUNCTION akceStabulkou(pcDBF, pcAkce)		&& zadan akce (pcAkce) na zvolenm DBF souboru
LOCAL xcSel, lcOldPath, llOK
xcSel=Alias()
llOK=.T.
lcOldPath=mySetDefault(gcDIRNAME)
select 0
IF CanIopenDBF(pcDBF, "exclusive")
	select 0
	use (pcDBF) exclusive alias TMPAKCE
	IF lErr3
		store .F. to lErr3		
	ELSE
		DO CASE
			CASE pcAkce=="REINDEX"
				IF .not.empty(CDX(1))
					Logging("reindex on table ", gcDIRNAME, pcDBF)
					REINDEX
				ENDIF
			CASE pcAKce=="PACK"
				PACK
				Logging("DBFlike table packed ", gcDIRNAME, pcDBF)
			CASE pcAkce=="BROWSE"
				myBrowse(.T., "")
				Logging("Table BROWSEd ", gcDIRNAME, pcDBF)
			CASE pcAkce=="MODISTRU"
				modify structure
				Logging("Table structure modified ", gcDIRNAME, pcDBF)
		ENDCASE
	ENDIF
	IF used("TMPAKCE")
		use in TMPAKCE
	ENDIF
ELSE
	llOK=.F.
ENDIF
CreateCursorSEZNAM()		&& if not exists, it creates it
select (iif(empty(xcSel), 0, (xcSel)) )
mySetDefault(lcOldPath)
RETURN llOK

*****


FUNCTION NactiSeznamSouboru()
local array laFiles(1, 2)
local lnCount, lnI, lnCP, lcOldPath, lnRecCount, llCDX
lcOldPath=mySetDefault(gcDIRNAME)
select SEZNAM
* delete all
zap
set order to tag FILENAME
lnCount=ADir(laFiles, gcMASKA, "ARH")
FOR lnI=1 to lnCount
	select 0
	use (laFiles(lnI, 1))
	IF lErr41
		Logging("ERR: MEMO file missing/invalid: ", laFiles(lnI, 1) )
		store .F. to lErr41
		loop
	ENDIF
	lnCP=CPdbf()
	lnRecCount=RecCount()
	llCDX=.not.empty(CDX(1))
	use
	select SEZNAM
	append blank
	replace				FILENAME		with		laFiles(lnI, 1),	;
								OLDCP				with		lnCP,							;
								NEWCP				with		gnNewCP,					;
								ID					with		RecNo(),					;
								TEXTY				with		glTEXTY,					;
								FILESIZE		with		laFiles(lnI, 2),	;
								RECCOUNT		with		lnRecCount,				;
								CDX					with		llCDX,						;
								REINDEX			with		min(glREINDEX, llCDX)
ENDFOR
go top
mySetDefault(lcOldPath)
RETURN lnCount

*****

FUNCTION ProvestPrekodovani(oTHISFORM)
local lcOldPath, lcZprava

lcOldPath=mySetDefault(gcDIRNAME)
select SEZNAM
set order to
WITH oTHISFORM
	.PROGRESSBAR.Min=0
	.PROGRESSBAR.Max=RecCount()
	.PROGRESSBAR.Value=0
	.PROGRESSBAR.Visible=.T.
ENDWITH
SCAN ALL
	lcZprava=""

	* pekdovn char pol, je-li poadovno
	IF OLDCP != NEWCP
		IF SEZNAM.TEXTY
			lcZprava=lcZPrava + PrekodujTexty(SEZNAM.FILENAME, SEZNAM.NEWCP)
		ELSE					&& jenom POKE do hlaviky DBFsouboru
			lcZprava=lcZprava + CPzero(SEZNAM.FILENAME, SEZNAM.NEWCP)
		ENDIF
	ENDIF
	
	* reindex, je-li poadovn a CDX nalezen
	IF SEZNAM.REINDEX
		IF .not.used("TMPDBF")
			select 0
			use (SEZNAM.FILENAME) alias TMPDBF exclusive
		ENDIF
		If .not.empty(CDX(1))
			reindex
		EndIf
		use in TMPDBF
	ENDIF

	select SEZNAM
	replace			ZPRAVA			with		lcZprava
	Logging("Converted file ", gcDIRNAME, alltrim(SEZNAM.FILENAME) )
	oTHISFORM.PROGRESSBAR.Value=RecNo()
ENDSCAN
oTHISFORM.PROGRESSBAR.Visible=.F.
go top
mySetDefault(lcOldPath)
RETURN .T.

*****

FUNCTION PrekodujTexty(lcInputDBF, lnNewCP)			&& 
local xcTmpDbf, xcExt, xcSel
xcSel=Alias()
xcTmpDbf=GetNewTmp()+".dbf"
select 0
use (lcInputDBF) alias INPUTFILE shared
xcExt=Upper(JustExt(lcInputDBF))
set NoCPtrans to
DO CASE
			CASE xcExt=="DBF"
				set NoCPtrans to &cDBFnoCPtrans.
			CASE xcExt=="SCX"
				set NoCPtrans to &cSCXnoCPtrans.
			CASE xcExt=="MNX"
				set NoCPtrans to &cMNXnoCPtrans.
			CASE xcExt=="VCX"
				set NoCPtrans to &cVCXnoCPtrans.
			CASE xcExt=="FRX"
				set NoCPtrans to &cFRXnoCPtrans.
			CASE xcExt=="PJX"
				set NoCPtrans to &cPJXnoCPtrans.
			CASE xcExt=="LBX"
				set NoCPtrans to &cLBXnoCPtrans.
ENDCASE
copy to (xcTmpDbf) with CDX
use (xcTmpDbf) alias INPUTFILE
erase (lcInputDBF)
copy to (lcInputDBF) as lnNewCP with CDX
use
select (iif(empty(xcSel), 0, (xcSel)) )
RETURN ""



RETURN .T.
****
FUNCTION CreateCursorSEZNAM()
local llOK
llOK=.F.
IF used("SEZNAM")
	llOK=.F.
ELSE
	select 0
	create cursor SEZNAM (ID I, FILENAME C(80), OLDCP I, NEWCP I, REINDEX L, TEXTY L, FILESIZE I, RECCOUNT I, CDX L, ZPRAVA C(40) )
	index on ID tag ID
	index on FILENAME tag FILENAME
	llOK=.T.
ENDIF
RETURN llOK

****************


FUNCTION CPZERO(m.fname, m.cpbyte)
* CPZERO -- Poke a codepage byte into a database header
* Author: Walter Kennamer
* Copyright Microsoft Corp, 1993-1996
*
* Usage: 
*    DO CPZERO WITH dbfname                     && marks the database with codepage 0 (i.e., no codepage)
* 
*    DO CPZERO WITH dbfname, codepage_number    && marks the database with specified codepage
*
* Some common valid numbers are:
*   Windows            1252
*   DOS                 437
*   International DOS   850
*

*LPARAMETER m.fname, m.cpbyte

#define C_TOTAL 22     && total code page numbers supported
local m.fp_in, m.buf, m.found_one, m.i, m.outbyte

IF PARAMETERS() < 2
   m.cpbyte = 0
ENDIF   


#define c_buf_size 32

#define c_noopen   1
#define c_badbyte  2
#define c_notfox   3
#define c_maxerror 4


DECLARE error_array[c_maxerror]
error_array[c_noopen] = "The table could not be opened."
error_array[c_badbyte] = "Invalid code page specified."
error_array[c_notfox] = "Not a FoxPro table."




* Set up table of code pages and DBF bytes numbers
DIMENSION cpnums[C_TOTAL,2] 
cpnums[ 1,1] = 437
cpnums[ 1,2] = 1
cpnums[ 2,1] = 850
cpnums[ 2,2] = 2
cpnums[ 3,1] = 1252
cpnums[ 3,2] = 3
cpnums[ 4,1] = 10000
cpnums[ 4,2] = 4
cpnums[ 5,1] = 852
cpnums[ 5,2] = 100
cpnums[ 6,1] = 866
cpnums[ 6,2] = 101
cpnums[ 7,1] = 865
cpnums[ 7,2] = 102
cpnums[ 8,1] = 861
cpnums[ 8,2] = 103
cpnums[ 9,1] = 895
cpnums[ 9,2] = 104
cpnums[10,1] = 620
cpnums[10,2] = 105
cpnums[11,1] = 737
cpnums[11,2] = 106
cpnums[12,1] = 857
cpnums[12,2] = 107
cpnums[13,1] = 863
cpnums[13,2] = 108
cpnums[14,1] = 10007
cpnums[14,2] = 150
cpnums[15,1] = 10029
cpnums[15,2] = 151
cpnums[16,1] = 10006
cpnums[16,2] = 152
cpnums[17,1] = 1250
cpnums[17,2] = 200
cpnums[18,1] = 1251
cpnums[18,2] = 201
cpnums[19,1] = 1253
cpnums[19,2] = 203
cpnums[20,1] = 1254
cpnums[20,2] = 202
cpnums[21,1] = 1257
cpnums[21,2] = 204
cpnums[22,1] = 0
cpnums[22,2] = 0

IF !EMPTY(m.fname)
*   CLOSE DATABASES
   m.outbyte = m.cpbyte
   m.found_one = .F.
   FOR m.i = 1 TO C_TOTAL
      IF m.cpbyte = cpnums[m.i,1]
         m.outbyte = cpnums[m.i,2]
         m.found_one = .T.
         EXIT
      ENDIF
   ENDFOR
   IF m.found_one
      m.cpbyte = m.outbyte
   ELSE
      * Was it a valid DBF byte if it wasn't a valid code page?
      FOR m.i = 1 TO C_TOTAL
         IF m.cpbyte = cpnums[m.i,2]
            m.found_one = .T.
         ENDIF
      ENDFOR
      IF !m.found_one
*         DO errormsg WITH c_badbyte
         RETURN "Selected unknown CP "
      ENDIF
   ENDIF
   
   IF FILE(m.fname)
       m.fp_in = FOPEN(m.fname,2)
       IF m.fp_in > 0
          * First check that we have a FoxPro table...
          m.buf=FREAD(m.fp_in,c_buf_size)
          IF ( SUBSTR(m.buf,1,1) = CHR(139) OR SUBSTR(m.buf,1,1) = CHR(203);
             OR SUBSTR(m.buf,31,1) != CHR(0) OR SUBSTR(m.buf,32,1) != CHR(0) )
              =fclose(m.fp_in)
*              DO errormsg WITH c_notfox
              RETURN "Not std. DBF table "
          ELSE
              * Now poke the codepage id into byte 29
              =FSEEK(m.fp_in,29)
              =FWRITE(m.fp_in,CHR(m.cpbyte)) 
              =FCLOSE(m.fp_in)
          ENDIF
       ELSE
*          DO errormsg WITH c_noopen
          RETURN "Failed to open the file "
       ENDIF
    ELSE
*       DO errormsg WITH c_noopen
       RETURN "Failed to open the file "
    ENDIF
ENDIF      
RETURN ""


***** never run - kvuli kompilaci

myEscape()
ErrTrap()
CSoff()

*****
